"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request-promise");
var Categories;
(function (Categories) {
    Categories["Work"] = "Work";
})(Categories = exports.Categories || (exports.Categories = {}));
var Subcategories;
(function (Subcategories) {
    Subcategories["All"] = "All";
})(Subcategories = exports.Subcategories || (exports.Subcategories = {}));
var Types;
(function (Types) {
    Types["New"] = "New";
    Types["Renewal"] = "Renewal";
})(Types = exports.Types || (exports.Types = {}));
function buildUrl(type, category, subcategory) {
    return `https://burghquayregistrationoffice.inis.gov.ie/Website/AMSREG/AMSRegWeb.nsf/(getAppsNear)?openpage&cat=${category}&sbcat=${subcategory}&typ=${type}&_=1507583431263`;
}
function gnibIreland(type = Types.New, category = Categories.Work, subcategory = Subcategories.All) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const response = yield request({
                url: buildUrl(type, category, subcategory),
                ciphers: 'DES-CBC3-SHA',
                rejectUnauthorized: false
            });
            return JSON.parse(response);
        }
        catch (e) {
            console.log(e);
        }
    });
}
exports.gnibIreland = gnibIreland;
